//*************************************************************************
//                                                                        *
//                       IEDownload Demo                                  *                                                      *
//                            by                                          *
//                     Per Linds Larsen                                  *
//                                                                        *
//  Contributions:                                                        *
//  Eran Bodankin -bsalsa(bsalsa@bsalsa.com) (All the new stuf)           *
//  Updated versions:                                                     *
//               http://www.bsalsa.com                                    *
//*************************************************************************
{LICENSE:
THIS SOFTWARE IS PROVIDED TO YOU "AS IS" WITHOUT WARRANTY OF ANY KIND,
EITHER EXPRESSED OR IMPLIED INCLUDING BUT NOT LIMITED TO THE APPLIED
WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A PARTICULAR PURPOSE.
YOU ASSUME THE ENTIRE RISK AS TO THE ACCURACY AND THE USE OF THE SOFTWARE
AND ALL OTHER RISK ARISING OUT OF THE USE OR PERFORMANCE OF THIS SOFTWARE
AND DOCUMENTATION. [YOUR NAME] DOES NOT WARRANT THAT THE SOFTWARE IS ERROR-FREE
OR WILL OPERATE WITHOUT INTERRUPTION. THE SOFTWARE IS NOT DESIGNED, INTENDED
OR LICENSED FOR USE IN HAZARDOUS ENVIRONMENTS REQUIRING FAIL-SAFE CONTROLS,
INCLUDING WITHOUT LIMITATION, THE DESIGN, CONSTRUCTION, MAINTENANCE OR
OPERATION OF NUCLEAR FACILITIES, AIRCRAFT NAVIGATION OR COMMUNICATION SYSTEMS,
AIR TRAFFIC CONTROL, AND LIFE SUPPORT OR WEAPONS SYSTEMS. VSOFT SPECIFICALLY
DISCLAIMS ANY EXPRESS OR IMPLIED WARRANTY OF FITNESS FOR SUCH PURPOSE.

You may use, change or modify the component under 3 conditions:
1. In your website, add a link to "http://www.bsalsa.com"
2. In your application, add credits to "Embedded Web Browser"
3. Mail me  (bsalsa@bsalsa.com) any code change in the unit
   for the benefit of the other users.
4. Please, consider donation in our web site!
{*******************************************************************************}


unit Downloaddemo_U;

interface

uses
   windows, Dialogs, SysUtils, Classes, Forms, UrlMon, IEDownload, StdCtrls, Controls,
   ComCtrls, OleCtrls, SHDocVw_EWB, EmbeddedWB, IEAddress, ExtCtrls;

type
   TMyRecord = record
      ulProgress: string;
      ElapsedTime: string;
      Speed: string;
      EstimatedTime: string;
      Url: string;
   end;
   PMyRecord = ^TMyRecord;

type
   TForm1 = class(TForm)
      IEDownload1: TIEDownload;
      StatusBar1: TStatusBar;
      Panel1: TPanel;
      Panel2: TPanel;
      btnStart: TButton;
      btnStop: TButton;
      memo1: TMemo;
      memo2: TMemo;
      Label1: TLabel;
      Label2: TLabel;
      IEAddress1: TIEAddress;
      Panel3: TPanel;
      Panel4: TPanel;
      EmbeddedWB1: TEmbeddedWB;
      ListView: TListView;
      ProgressBar1: TProgressBar;
    procedure IEDownload1Progress(Sender: TBSCB; ulProgress, ulProgressMax,
      ulStatusCode: Cardinal; szStatusText: PWideChar; Downloaded, ElapsedTime,
      Speed, RemainingTime, Status: string);
      function IEDownload1BeginningTransaction(Sender: TBSCB; szURL,
         szHeaders: PWideChar; dwReserved: Cardinal;
         out szAdditionalHeaders: PWideChar): HRESULT;
      procedure IEDownload1BusyStateChange(Sender: TObject);
      procedure FormShow(Sender: TObject);
      procedure btnStopClick(Sender: TObject);
      procedure IEDownload1ErrorText(Sender: TBSCB; Text: string);
      procedure IEDownload1RespondText(Sender: TBSCB; Text: string);
      procedure IEDownload1StatusText(Sender: TBSCB; Text: string);
      procedure btnStartClick(Sender: TObject);
      procedure IEDownload1Data(Sender: TBSCB; var Buffer: PByte;
         var BufLength: Cardinal);
      procedure IEDownload1Complete(Sender: TBSCB; Stream: TStream;
         Result: HRESULT);
   private
    { Private declarations }
   end;

var
   Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.btnStartClick(Sender: TObject);
begin
   IEDownload1.Go(IEAddress1.Text);
end;

procedure TForm1.btnStopClick(Sender: TObject);
begin
   IEDownload1.cancel;
end;

procedure TForm1.IEDownload1Data(Sender: TBSCB; var Buffer: PByte;
   var BufLength: Cardinal);    
begin
   memo2.Lines.Add(PChar(Buffer));
end;

procedure TForm1.FormShow(Sender: TObject);
begin
   EmbeddedWB1.AssignEmptyDocument;
end;

function TForm1.IEDownload1BeginningTransaction(Sender: TBSCB; szURL,
   szHeaders: PWideChar; dwReserved: Cardinal;
   out szAdditionalHeaders: PWideChar): HRESULT;
begin
   memo1.Lines.Add('Downloading from:' + IEDownload1.Url);
   Result := S_OK;
end;

procedure TForm1.IEDownload1BusyStateChange(Sender: TObject);
begin
   btnStart.Enabled := not IEDownload1.Busy;
   btnStop.Enabled := IEDownload1.Busy;
end;

procedure TForm1.IEDownload1Complete(Sender: TBSCB; Stream: TStream;
   Result: HRESULT);
begin
   if (Result = S_OK) and (Stream <> nil) then
      begin
        EmbeddedWB1.LoadFromStream(Stream);
        memo1.Lines.Add('Download complete...');
      end
   else
      memo1.Lines.Add(ErrorText(Result) + ' ' + ResponseCodeText(Sender.ResponseCode));
end;

procedure TForm1.IEDownload1Progress(Sender: TBSCB; ulProgress, ulProgressMax,
  ulStatusCode: Cardinal; szStatusText: PWideChar; Downloaded, ElapsedTime,
  Speed, RemainingTime, Status: string);
   var
   ListItem: TListItem;
   st: string;
begin
   ProgressBar1.Max := ulProgressMax;
   ProgressBar1.Position := ulProgress;
   ListView.Items.BeginUpdate();
   ListItem := ListView.Items.Add();
   ListItem.Caption := IEAddress1.Text;
   ListItem.SubItems.Add(Speed);
   ListItem.SubItems.Add(Downloaded);
   ListItem.SubItems.Add(RemainingTime);
   ListItem.SubItems.Add(ElapsedTime);
   ListItem.SubItems.Add(Status);
   ListView.Items.EndUpdate();
   st := BindStatusText(ulStatusCode);
   if ulStatusCode = BINDSTATUS_DOWNLOADINGDATA then
      begin
         st := st + ' (' + InttoStr(ulProgress) + '/' + IntToStr(ulProgressMax) + ')';
         memo1.Lines.Add(st);
      end;
end;

procedure TForm1.IEDownload1StatusText(Sender: TBSCB; Text: string);
begin
   StatusBar1.Panels[0].Text := 'Status: ' + Text;
end;

procedure TForm1.IEDownload1ErrorText(Sender: TBSCB; Text: string);
begin
   StatusBar1.Panels[1].Text := 'Errors: ' + Text;
end;

procedure TForm1.IEDownload1RespondText(Sender: TBSCB; Text: string);
begin
   StatusBar1.Panels[2].Text := 'Respond: ' + Text;
end;

end.

